'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _desc, _value, _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _FieldType = require('../FieldType');

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _keys = require('lodash/keys');

var _keys2 = _interopRequireDefault(_keys);

var _pick = require('lodash/pick');

var _pick2 = _interopRequireDefault(_pick);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _autobindDecorator = require('autobind-decorator');

var _autobindDecorator2 = _interopRequireDefault(_autobindDecorator);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Contexts = require('../Contexts');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

var Field = (_class = (_temp = _class2 = function (_React$Component) {
  (0, _inherits3.default)(Field, _React$Component);

  function Field() {
    (0, _classCallCheck3.default)(this, Field);
    return (0, _possibleConstructorReturn3.default)(this, (Field.__proto__ || Object.getPrototypeOf(Field)).apply(this, arguments));
  }

  (0, _createClass3.default)(Field, [{
    key: 'getFieldName',
    value: function getFieldName(parentFieldName) {
      if (parentFieldName) {
        if (this.props.fieldName) {
          return parentFieldName + '.' + this.props.fieldName;
        } else {
          return parentFieldName;
        }
      } else {
        return this.props.fieldName;
      }
    }
  }, {
    key: 'focus',
    value: function focus() {
      if (!this.refs.input.focus) {
        throw new Error("Field doesn't has a focus method");
      }
      this.refs.input.focus();
    }
  }, {
    key: 'getComponent',
    value: function getComponent() {
      return this.props.type;
    }
  }, {
    key: 'getErrorMessage',
    value: function getErrorMessage(errorMessages) {
      return this.props.errorMessage || errorMessages[this.getFieldName()] || (0, _get2.default)(errorMessages, this.getFieldName());
    }
  }, {
    key: 'getChildProps',
    value: function getChildProps(_ref) {
      var _this2 = this;

      var value = _ref.value,
          parentFieldName = _ref.parentFieldName,
          _onChange = _ref.onChange,
          errorMessages = _ref.errorMessages;

      /**
       * This gets the props that are defined in the propTypes of the registered component.
       */
      var fieldComponent = this.getComponent();
      var propOptions = (0, _omit2.default)(this.props, (0, _keys2.default)(Field.propTypes));
      var allowedKeys = (0, _keys2.default)((0, _extends3.default)({}, _FieldType.propTypes, fieldComponent.propTypes));
      var onlyAllowedOptions = (0, _pick2.default)(propOptions, allowedKeys);

      /**
       * Options that are not registered in the propTypes are passed separatly.
       * This options are in the variable this.passProps of the component, they should be
       * passed to the main component of it.
       */
      allowedKeys.push('type');
      var notDefinedOptions = (0, _omit2.default)(propOptions, allowedKeys);

      var props = (0, _extends3.default)({
        value: (0, _get2.default)(value || {}, this.props.fieldName),
        onChange: function onChange(newValue) {
          return _onChange(_this2.getFieldName(parentFieldName), newValue);
        },
        errorMessage: this.getErrorMessage(errorMessages || {}),
        fieldName: this.getFieldName(parentFieldName),
        passProps: notDefinedOptions
      }, onlyAllowedOptions);

      return props;
    }
  }, {
    key: 'renderComponent',
    value: function renderComponent(info) {
      var Component = this.getComponent();
      var props = this.getChildProps(info);
      return _react2.default.createElement(
        _Contexts.ValueContext.Provider,
        { value: props.value },
        _react2.default.createElement(Component, props)
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      return _react2.default.createElement(
        _Contexts.ValueContext.Consumer,
        null,
        function (value) {
          return _react2.default.createElement(
            _Contexts.ErrorMessagesContext.Consumer,
            null,
            function (errorMessages) {
              return _react2.default.createElement(
                _Contexts.OnChangeContext.Consumer,
                null,
                function (onChange) {
                  return _react2.default.createElement(
                    _Contexts.ParentFieldNameContext.Consumer,
                    null,
                    function (parentFieldName) {
                      return _this3.renderComponent({
                        value: value,
                        parentFieldName: parentFieldName,
                        onChange: onChange,
                        errorMessages: errorMessages
                      });
                    }
                  );
                }
              );
            }
          );
        }
      );
    }
  }]);
  return Field;
}(_react2.default.Component), _class2.propTypes = {
  /**
   * The name of the field in the object.
   */
  fieldName: _propTypes2.default.string.isRequired,

  /**
   * The type of the input. It can be a component
   */
  type: _propTypes2.default.any,

  /**
   * Pass a error message
   */
  errorMessage: _propTypes2.default.string
}, _temp), (_applyDecoratedDescriptor(_class.prototype, 'focus', [_autobindDecorator2.default], Object.getOwnPropertyDescriptor(_class.prototype, 'focus'), _class.prototype)), _class);
exports.default = Field;